`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/23 01:51:38
// Design Name: 
// Module Name: calculator
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module calculator(
    input [3:0]cal,
    input [3:0]data1,
    input [3:0]data2,
    input [3:0]data3,
    input [3:0]data4,
    output reg [3:0]sum3,
    output reg [3:0]sum2,
    output reg [3:0]sum1,
    output reg [3:0]sum0
    );
    reg [3:0]sign;
    reg [6:0]sum_sub;

always@*
  if (data2 * 10 + data1 >= data4 * 10 + data3)
    begin
      sign = 4'd15;
      sum_sub = data2 * 10 + data1 - (data4 * 10 + data3);
    end
  else
    begin
      sign = 4'd11;
      sum_sub = data4 * 10 + data3 - (data2 * 10 + data1);
    end

always@*
  case (cal)
    4'd10:
      begin
        sum3 = 4'd15;
        sum2 = (data2 * 10 + data1 + data4 * 10 + data3) / 100;
        sum1 = ((data2 * 10 + data1 + data4 * 10 + data3) - sum2 * 100) / 10;
        sum0 = (data2 * 10 + data1 + data4 * 10 + data3) - sum2 * 100 - sum1 * 10;
      end
    4'd11:
      begin
        sum3 = 4'd15;
        sum2 = sign;
        sum1 = sum_sub / 10;
        sum0 = sum_sub - sum1 * 10;
      end
    4'd12:
      begin
        sum3 = (data2 * 10 + data1) * (data4 * 10 + data3) / 1000;
        sum2 = ((data2 * 10 + data1) * (data4 * 10 + data3) - sum3 * 1000) / 100;
        sum1 = ((data2 * 10 + data1) * (data4 * 10 + data3) - sum3 * 1000 - sum2 * 100) / 10;
        sum0 = (data2 * 10 + data1) * (data4 * 10 + data3) - sum3 * 1000 - sum2 * 100 - sum1 * 10;
      end
    default:
      begin
        sum3 = 4'd15;
        sum2 = 4'd15;
        sum1 = 4'd15;
        sum0 = 4'd15;
      end
    endcase

endmodule
