`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/22 22:19:55
// Design Name: 
// Module Name: fsm
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module fsm(
    input [8:0]last_change,
    input key_valid,
    input clk,
    input rst_n,
    output reg [1:0]show,
    output reg [8:0]value1,
    output reg [8:0]value2,
    output reg [8:0]value3,
    output reg [8:0]value4,
    output reg [8:0]cal
    );
    reg [2:0]state, next_state;
    reg cnt, cnt_tmp;
    reg [8:0]value_tmp1, value_tmp2, value_tmp3, value_tmp4;

always@(posedge clk or negedge rst_n)
  if (~rst_n)
    cnt <= 0;
  else
    cnt <= cnt_tmp;

always@*
  if (key_valid)
    cnt_tmp = cnt + 1;
  else
    cnt_tmp = cnt;

always@*
  case (state)
    3'b000:
      if (key_valid && cnt)
      begin
        next_state = 3'b001;
        value_tmp4 = value4;
        value_tmp3 = value3;
        value_tmp2 = 9'h70;
        value_tmp1 = last_change;
        show = 2'b00;
        cal = cal;
      end
      else
      begin
        next_state = 3'b000;
        value_tmp4 = value4;
        value_tmp3 = value3;
        value_tmp2 = value2;
        value_tmp1 = value1;
        show = 2'b11;
        cal = cal;
      end
    3'b001:
        if ((last_change == 9'h79 || last_change == 9'h7B || last_change == 9'h7C) && cnt && key_valid)
        begin
          next_state = 3'b011;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b01;
          cal = last_change;
        end
        else if (key_valid && cnt)
        begin
          next_state = 3'b010;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value1;
          value_tmp1 = last_change;
          show = 2'b00;
          cal = cal;
        end
        else
        begin
          next_state = 3'b001;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b00;
          cal = cal;
        end    
    3'b010:
        if ((last_change == 9'h79 || last_change == 9'h7B || last_change == 9'h7C) && cnt && key_valid)
        begin
          next_state = 3'b011;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b01;
          cal = last_change;
        end
        else 
        begin
          next_state = 3'b010;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b00;
          cal = cal;
        end
    3'b011:
        if (key_valid && cnt)
        begin
          next_state = 3'b100;
          value_tmp4 = 9'h70;
          value_tmp3 = last_change;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b10;
          cal = cal;
        end
        else 
        begin
          next_state = 3'b011;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b01;
          cal = cal;
        end
    3'b100:
        if (last_change == 9'h5A && cnt && key_valid)
        begin
          next_state = 3'b000;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b11;
          cal = cal;
        end
        else if (key_valid && cnt)
        begin
          next_state = 3'b101;
          value_tmp4 = value3;
          value_tmp3 = last_change;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b10;
          cal = cal;
        end
        else 
        begin
          next_state = 3'b100;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b10;
          cal = cal;
        end
    3'b101:
        if (last_change == 9'h5A && cnt && key_valid)
        begin
          next_state = 3'b000;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b11;
          cal = cal;
        end
        else 
        begin
          next_state = 3'b101;
          value_tmp4 = value4;
          value_tmp3 = value3;
          value_tmp2 = value2;
          value_tmp1 = value1;
          show = 2'b10;
          cal = cal;
        end
    default:
    begin
      next_state = 3'b000;
      value_tmp4 = value4;
      value_tmp3 = value3;
      value_tmp2 = value2;
      value_tmp1 = value1;
      show = 2'b11;
      cal = cal;
    end
  endcase

always@(posedge clk or negedge rst_n)
  if (~rst_n)
  begin
    state <= 3'b000;
    value1 <= 0;
    value2 <= 0;
    value3 <= 0;
    value4 <= 0;
  end
  else
  begin
    state <= next_state;
    value1 <= value_tmp1;
    value2 <= value_tmp2;
    value3 <= value_tmp3;
    value4 <= value_tmp4;
  end

endmodule
