`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/22 23:49:31
// Design Name: 
// Module Name: top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top(
    inout PS2_DATA,
    inout PS2_CLK,
    input rst,
    input clk,
    output [3:0]ssd,
    output [7:0]seg
    );
    wire [511:0]key_down;
    wire [8:0]last_change;
    wire key_valid;
    wire [1:0]show;
    wire [8:0]value1, value2, value3, value4, cal;
    wire [3:0]out1, out2, out3, out4, cal_out;
    wire [3:0]digit3, digit2, digit1, digit0;
    wire [1:0]ssd_ctl_en;
    wire [3:0]ssd_in;
    wire [3:0]sum3, sum2, sum1, sum0;

    KeyboardDecoder U0(
        .key_down(key_down),
        .last_change(last_change),
        .key_valid(key_valid),
        .PS2_DATA(PS2_DATA),
        .PS2_CLK(PS2_CLK),
        .rst(~rst),
        .clk(clk)
    );

    fsm U1(
        .last_change(last_change),
        .key_valid(key_valid),
        .clk(clk),
        .rst_n(rst),
        .show(show),
        .value1(value1),
        .value2(value2),
        .value3(value3),
        .value4(value4),
        .cal(cal)
    );

    data_decoder U2(
        .value1(value1),
        .value2(value2),
        .value3(value3),
        .value4(value4),
        .cal(cal),
        .out1(out1),
        .out2(out2),
        .out3(out3),
        .out4(out4),
        .cal_out(cal_out)
    );

    calculator U3(
        .cal(cal_out),
        .data1(out1),
        .data2(out2),
        .data3(out3),
        .data4(out4),
        .sum3(sum3),
        .sum2(sum2),
        .sum1(sum1),
        .sum0(sum0)
    );

    mode U4(
        .show(show),
        .value1(out1),
        .value2(out2),
        .value3(out3),
        .value4(out4),
        .sum3(sum3),
        .sum2(sum2),
        .sum1(sum1),
        .sum0(sum0),
        .cal(cal_out),
        .digit0(digit0),
        .digit1(digit1),
        .digit2(digit2),
        .digit3(digit3)
    );

    freq_div U5(
        .clk(clk),
        .rst_n(rst),
        .clk_ctl(ssd_ctl_en)
    );

    scan_ctl U7(
        .ssd_ctl_en(ssd_ctl_en),
        .in3(digit3),
        .in2(digit2),
        .in1(digit1),
        .in0(digit0),
        .ssd_ctl(ssd),
        .ssd_in(ssd_in)
    );

    display_decoder U8(
        .in(ssd_in),
        .segs(seg)
    );
endmodule
